<?php

function my_xml2array($__url)
{
    $xml_values = array();
    $contents = file_get_contents($__url);
    $parser = xml_parser_create('');
    if(!$parser)
        return false;

    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, 'UTF-8');
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);
    if (!$xml_values)
        return array();
   
    $xml_array = array();
    $last_tag_ar =& $xml_array;
    $parents = array();
    $last_counter_in_tag = array(1=>0);
    foreach ($xml_values as $data)
    {
        switch($data['type'])
        {
            case 'open':
                $last_counter_in_tag[$data['level']+1] = 0;
                $new_tag = array('name' => $data['tag']);
                if(isset($data['attributes']))
                    $new_tag['attributes'] = $data['attributes'];
                if(isset($data['value']) && trim($data['value']))
                    $new_tag['value'] = trim($data['value']);
                $last_tag_ar[$last_counter_in_tag[$data['level']]] = $new_tag;
                $parents[$data['level']] =& $last_tag_ar;
                $last_tag_ar =& $last_tag_ar[$last_counter_in_tag[$data['level']]++];
                break;
            case 'complete':
                $new_tag = array('name' => $data['tag']);
                if(isset($data['attributes']))
                    $new_tag['attributes'] = $data['attributes'];
                if(isset($data['value']) && trim($data['value']))
                    $new_tag['value'] = trim($data['value']);

                $last_count = count($last_tag_ar)-1;
                $last_tag_ar[$last_counter_in_tag[$data['level']]++] = $new_tag;
                break;
            case 'close':
                $last_tag_ar =& $parents[$data['level']];
                break;
            default:
                break;
        };
    }
    return $xml_array;
}

function parse_event_xml_url( $url )
{
	$arr = my_xml2array($url);
	$rdf = $arr[0];
	foreach( $rdf["attributes"] as $attr=>$val )
	{
		if( $attr == "xmlbase" ) { $xmlbase = $val; }
		if( $attr == "xmlns" ) { $ns[""] = $val; }
		if( preg_match( '/^xmlns:(.*)/', $attr, $r ) )
		{
			$ns[$r[1]] = $val;
		}
	}
	for( $i=0;$i<sizeof($rdf)-2;++$i)
	{
		$value = $rdf[$i];
		$type = $value["name"];
		$uri = $value["attributes"]["rdf:about"];
		for( $j=0;$j<sizeof($value)-2;++$j )
		{
			$pred = $value[$j];
			if( isset( $pred["value"] ) )
			{
				$d[$type][$uri][$pred["name"]][] = $pred["value"];
			}
			else
			{
				$d[$type][$uri][$pred["name"]][] = $pred["attributes"]["rdf:resource"];
			}
		}
	}
	
	return $d;
}
	

function render_prog( $d, $prog_id, $voffset, $base_event_url )
{
	$H = 600;

	$prog = $d["Programme"][$prog_id];
	$earliest = 9999999999999999;
	$latest = 0;
	foreach( $prog["hasTimeSlot"] as $event_id )
	{
		$ts = $d["TimeSlot"][$event_id];
		$start = iso_to_timet( $ts["cal:dtstart"][0] );
		$end = iso_to_timet( $ts["cal:dtend"][0] );
		if( $start < $earliest ) { $earliest = $start; }
		if( $end > $latest ) { $latest = $end; }
	}
	foreach( $prog["hasUnstreamedEvent"] as $event_id )
	{
		$event = $d["Event"][$event_id];
		$start = iso_to_timet( $event["cal:dtstart"][0] );
		$end = iso_to_timet( $event["cal:dtend"][0] );
		if( $start < $earliest ) { $earliest = $start; }
		if( $end > $latest ) { $latest = $end; }
	}
	foreach( $prog["hasStreamedEvent"] as $event_id )
	{
		$event = $d["Event"][$event_id];
		$start = iso_to_timet( $event["cal:dtstart"][0] );
		$end = iso_to_timet( $event["cal:dtend"][0] );
		$locations[$event["swc:hasLocation"][0]][] = $event_id;
		if( $start < $earliest ) { $earliest = $start; }
		if( $end > $latest ) { $latest = $end; }
	}
	$r = array();
	$range = $latest-$earliest;
	$W = 1000;
	$col = $W/(sizeof( $locations ) + 1 );
	$g = 2; #gutter
	$stream_title_h = 80;
	$prog_title_h = 35;
	$header_h = $stream_title_h + $prog_title_h;



	$p = 3;
	$b = 1;
	$y = $voffset+$g;
	$x = $col + $g;
	$h = $prog_title_h-$b-$b-$p-$p-$g-$g;
	$w = $col*sizeof( $locations )-$b-$b-$p-$p-$g-$g;	
	$r[] = "<div style='font-size: 120%; font-weight:bold;vertical-align: center; padding: ${p}px; border: solid ${b}px black; text-align:center;width: ${w}px;position: absolute; height:${h}px;left: ${x}px; top:${y}px;overflow: hide;background-color:#ccc'>".$prog["rdfs:label"][0]."</div>";
	
	foreach( $prog["hasTimeSlot"] as $event_id )
	{
		$ts = $d["TimeSlot"][$event_id];
		$start = iso_to_timet( $ts["cal:dtstart"][0] );
		$end = iso_to_timet( $ts["cal:dtend"][0] );
		$p = 3;
		$b = 1;
		$y = $H*($start-$earliest)/$range+$header_h+$voffset;
		$h = $H*($end-$start)/$range-$b-$b-$p-$p;
		$w = $col-$b-$b-$p-$p-$g-$g;
		$r[] = "<div style='padding: ${p}px; border: solid ${b}px black; text-align:center;width: ${w}px;position: absolute; height:${h}px;left: ${g}px; top:${y}px;overflow: hide;background-color:#ffc'>".$ts["cal:summary"][0]."</div>";
	}
	foreach( $prog["hasUnstreamedEvent"] as $event_id )
	{
		$event = $d["Event"][$event_id];
		$start = iso_to_timet( $event["cal:dtstart"][0] );
		$end = iso_to_timet( $event["cal:dtend"][0] );
		$p = 3;
		$b = 1;
		$y = $H*($start-$earliest)/$range+$header_h+$voffset;
		$x = $col + $g;
		$h = $H*($end-$start)/$range-$b-$b-$p-$p;
		$w = $col*sizeof( $locations )-$b-$b-$p-$p-$g-$g;	
		$r[] = "<div style='padding: ${p}px; border: solid ${b}px black; text-align:center;width: ${w}px;position: absolute; height:${h}px;left: ${x}px; top:${y}px;overflow: hide;background-color:#cff'>";
		$r[] = "<table style='width: 100%; height: ${h}px'><tr><td style='text-align: center'>";
		$r[] = "<a style='text-decoration:none' href='$base_event_url".preg_replace('/#/','', $event_id).".ics'>";
		$r[] = $event["cal:summary"][0];
		$r[] = "</a></td></tr></table></div>";
	}
	$n = 0;
	foreach( $locations as $loc_id=>$events )
	{
		++$n;
		$p = 3;
		$b = 1;
		$y = $g+$voffset+$prog_title_h;
		$x = $n*$col + $g;
		$h = $stream_title_h-$b-$b-$p-$p-$g-$g;
		$w = $col-$b-$b-$p-$p-$g-$g;	
		$loc = $d["Location"][$loc_id];
		$r[] = "<div style='vertical-align: center; padding: ${p}px; border: solid ${b}px black; text-align:center;width: ${w}px;position: absolute; height:${h}px;left: ${x}px; top:${y}px;overflow: hide;background-color:#fcc'>".$loc["rdfs:label"][0]."</div>";
		foreach( $events as $event_id )
		{
			$event = $d["Event"][$event_id];
			$start = iso_to_timet( $event["cal:dtstart"][0] );
			$end = iso_to_timet( $event["cal:dtend"][0] );
			$p = 3;
			$b = 1;
			$y = $H*($start-$earliest)/$range+$header_h+$voffset;
			$h = $H*($end-$start)/$range-$b-$b-$p-$p;

			$r[] = "<div style='vertical-align: center; padding: ${p}px; border: solid ${b}px black; text-align:center;width: ${w}px;position: absolute; height:${h}px;left: ${x}px; top:${y}px;overflow: hide;background-color:#ccf'>";
			$r[] = "<a style='text-decoration:none' href='$base_event_url".preg_replace('/#/','', $event_id).".ics'>";
			$r[] = $event["cal:summary"][0];
			$r[] = "</a></div>";
		}
	}

	return join( "",$r );
	
}

function iso_to_timet( $iso )
{
	$t = preg_split( '/[-: TZ]/',$iso );
	# h m s  m d y
	$mtime = mktime( $t[3]+0, $t[4]+0, $t[5]+0, $t[1]+0, $t[2]+0, $t[0]+0 );
	return $mtime;
}
